#! /usr/bin/env python
# -*- coding: utf-8 -*-
# vim:ts=4:expandtab:sw=4:tw=0
###############################################################################
# output.py - output modul for .dot format                                    #
#                                                                             #
# $Id: output_fast.py 170 2007-05-03 15:03:53Z smrcka $
#                                                                             #
# Author: Ales Smrcka <smrcka@fit.vutbr.cz>                                   #
#                                                                             #
# This program is free software; you can redistribute it and/or modify        #
#   it under the terms of the GNU General Public License as published by      #
#   the Free Software Foundation; either version 2 of the License, or         #
#   (at your option) any later version.                                       #
#   See http://www.gnu.org/licenses/gpl.html for more details.                #
#                                                                             #
###############################################################################

def transformate_automaton(ca):
    model ='digraph %s {\n' % ca.name
    model+='    rankdir=LR;\n'
    model+='    size="20,20";\n'
    model+='    %s [style=filled];\n' % ca.init_state.id
    i=1
    for t in ca.transitions:
        if t.guard==1:
            guard=''
        else:
            guard='%s: ' % infix(t.guard)
#            guard='g: '
        sa=["%s:=%s" % (a.counter.name,infix(a.value)) for a in t.actions]
        if t == ca.init_transition:
            sa += [infix(p.comment) for p in ca.parameters if p.comment]
        if sa:
            actions=', '.join(sa)
#            actions='a'
        else:
            actions=''
        label='%s%s' % (guard, actions)
        if label:
            label = ' [label="%s"]' % label
        model+='    %s -> %s%s;\n' % (t.s1.id, t.s2.id, label)
    model+='}\n'
    return model 

opmap={
    'not':'!',
    'and':'&&',
    'or':'||',
    '-':'-',
    '+':'+',
    '==':'=',
    '<':'<',
    '>':'>',
    '<=':'<=',
    '>=':'>=',
}

def infix(expr):
    if type(expr)==int:
        return str(expr)
    elif type(expr)==list:
        if expr[0]=='!=':
            return infix(['not',['==']+expr[1:]])
        else:
            if len(expr)>2:
                return '(%s)' % (opmap[expr[0]].join( \
                    [infix(o) for o in expr[1:]]))
            else:
                return '(%s%s)' % (opmap[expr[0]], infix(expr[1]))
    else: # VariableUse
        return str(expr.v)
